searchData={"items":[{"type":"module","title":"Babel","doc":"[![CI](https://github.com/alexocode/babel/actions/workflows/ci.yml/badge.svg)](https://github.com/alexocode/babel/actions/workflows/ci.yml)\n[![Coverage Status](https://coveralls.io/repos/github/alexocode/babel/badge.svg?branch=main)](https://coveralls.io/github/alexocode/babel?branch=main)\n[![Hexdocs.pm](https://img.shields.io/badge/hexdocs-online-blue)](https://hexdocs.pm/babel/)\n[![Hex.pm](https://img.shields.io/hexpm/v/babel.svg)](https://hex.pm/packages/babel)\n[![Hex.pm Downloads](https://img.shields.io/hexpm/dt/babel)](https://hex.pm/packages/babel)\n\nData transformations made easy.","ref":"Babel.html"},{"type":"module","title":"Table of Contents - Babel","doc":"- [Table of Contents](#module-table-of-contents)\n- [Installation](#module-installation)\n- [Usage](#module-usage)\n  - [Error Reporting](#module-error-reporting)\n- [Contributing](#module-contributing)","ref":"Babel.html#module-table-of-contents"},{"type":"module","title":"Installation - Babel","doc":"Simply add `babel` to your list of dependencies in your `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:babel, \"~> 1.0\"}\n  ]\nend\n```\n\nDifferences between the versions are explained in [the Changelog](https://github.com/alexocode/babel/blob/main/CHANGELOG.md).\n\nDocumentation gets generated with [ExDoc](https://github.com/elixir-lang/ex_doc) and can be viewed at [HexDocs][hexdocs].","ref":"Babel.html#module-installation"},{"type":"module","title":"Usage - Babel","doc":"`Babel` was born out of a desire to simplify non-trivial data transformation pipelines.\nTo focus on the \"happy path\" instead of having to write a bunch of boilerplate error handling code.\n\nBut don't listen to me, take a look for yourself:\n\n```elixir\npipeline =\n  Babel.begin()\n  |> Babel.fetch([\"some\", \"nested\", \"path\"])\n  |> Babel.map(Babel.into(%{atom_key: Babel.fetch(\"string-key\")}))\n\ndata = %{\n  \"some\" => %{\n    \"nested\" => %{\n      \"path\" => [\n        %{\"string-key\" => :value2},\n        %{\"string-key\" => :value2},\n        %{\"string-key\" => :value2}\n      ]\n    }\n  }\n}\n\nBabel.apply(pipeline, data)\n=> {:ok, [\n   %{atom_key: :value1},\n   %{atom_key: :value2},\n   %{atom_key: :value3}\n]}\n```","ref":"Babel.html#module-usage"},{"type":"module","title":"Error Reporting - Babel","doc":"Since you'll most likely build non-trivial transformation pipelines with `Babel` - which can fail at any given step - `Babel` ships with elaborate error reporting:\n\n```elixir\npipeline =\n  Babel.begin()\n  |> Babel.fetch([\"some\", \"nested\", \"path\"])\n  |> Babel.map(Babel.into(%{atom_key: Babel.fetch(\"string-key\")}))\n\ndata = %{\n  \"some\" => %{\n    \"nested\" => %{\n      \"path\" => [\n        %{\"unexpected-key\" => :value1},\n        %{\"unexpected-key\" => :value2},\n        %{\"unexpected-key\" => :value3}\n      ]\n    }\n  }\n}\n\nBabel.apply!(pipeline, data)\n```\n\nWhich will produce the following error:\n\n```\n** (Babel.Error) Failed to transform data: [not_found: \"string-key\", not_found: \"string-key\", not_found: \"string-key\"]\n\nRoot Cause(s):\n1. Babel.Trace {\n  data = %{\"unexpected-key\" => :value1}\n\n  Babel.fetch(\"string-key\")\n  |=> {:error, {:not_found, \"string-key\"}}\n}\n2. Babel.Trace {\n  data = %{\"unexpected-key\" => :value2}\n\n  Babel.fetch(\"string-key\")\n  |=> {:error, {:not_found, \"string-key\"}}\n}\n3. Babel.Trace {\n  data = %{\"unexpected-key\" => :value3}\n\n  Babel.fetch(\"string-key\")\n  |=> {:error, {:not_found, \"string-key\"}}\n}\n\nFull Trace:\nBabel.Trace {\n  data = %{\"some\" => %{\"nested\" => %{\"path\" => [%{\"unexpected-key\" => :value1}, %{\"unexpected-key\" => :value2}, %{\"unexpected-key\" => :value3}]}}}\n\n  Babel.Pipeline<>\n  |\n  | Babel.fetch([\"some\", \"nested\", \"path\"])\n  | |=< %{\"some\" => %{\"nested\" => %{\"path\" => [%{\"unexpected-key\" => :value1}, %{...}, ...]}}}\n  | |=> [%{\"unexpected-key\" => :value1}, %{\"unexpected-key\" => :value2}, %{\"unexpected-key\" => :value3}]\n  |\n  | Babel.map(Babel.into(%{atom_key: Babel.fetch(\"string-key\")}))\n  | |=< [%{\"unexpected-key\" => :value1}, %{\"unexpected-key\" => :value2}, %{\"unexpected-key\" => :value3}]\n  | |\n  | | Babel.into(%{atom_key: Babel.fetch(\"string-key\")})\n  | | |=< %{\"unexpected-key\" => :value1}\n  | | |\n  | | | Babel.fetch(\"string-key\")\n  | | | |=< %{\"unexpected-key\" => :value1}\n  | | | |=> {:error, {:not_found, \"string-key\"}}\n  | | |\n  | | |=> {:error, [not_found: \"string-key\"]}\n  | |\n  | | Babel.into(%{atom_key: Babel.fetch(\"string-key\")})\n  | | |=< %{\"unexpected-key\" => :value2}\n  | | |\n  | | | Babel.fetch(\"string-key\")\n  | | | |=< %{\"unexpected-key\" => :value2}\n  | | | |=> {:error, {:not_found, \"string-key\"}}\n  | | |\n  | | |=> {:error, [not_found: \"string-key\"]}\n  | |\n  | | Babel.into(%{atom_key: Babel.fetch(\"string-key\")})\n  | | |=< %{\"unexpected-key\" => :value3}\n  | | |\n  | | | Babel.fetch(\"string-key\")\n  | | | |=< %{\"unexpected-key\" => :value3}\n  | | | |=> {:error, {:not_found, \"string-key\"}}\n  | | |\n  | | |=> {:error, [not_found: \"string-key\"]}\n  | |\n  | |=> {:error, [not_found: \"string-key\", not_found: \"string-key\", not_found: \"string-key\"]}\n  |\n  |=> {:error, [not_found: \"string-key\", not_found: \"string-key\", not_found: \"string-key\"]}\n}\n```\n\n`Babel` achieves this by keeping track of all applied steps in a `Babel.Trace` struct.\nRendering of a `Babel.Trace` is done through a custom `Inspect` implementation.\n\nYou have to this information everywhere: in the `Babel.Error` message, in `iex`, and whenever you `inspect` a `Babel.Error` or `Babel.Trace`.","ref":"Babel.html#module-error-reporting"},{"type":"module","title":"Contributing - Babel","doc":"Contributions are always welcome but please read [our contribution guidelines](https://github.com/alexocode/babel/blob/main/CONTRIBUTING.md) before doing so.\n\n[hex]: https://hex.pm/packages/babel\n[hexdocs]: https://hexdocs.pm/babel","ref":"Babel.html#module-contributing"},{"type":"function","title":"Babel.apply/2","doc":"Tries to transform the given `data` as described by the given `Babel.Applicable`.\n\nIf the `Babel.Applicable` transforms the data successfully it returns `{:ok, output}`,\nwhere `output` is whatever the given `Babel.Applicable` produces.\n\nIn case of failure an `{:error, Babel.Error.t}` is returned, which contains the failure\n`reason` and a `Babel.Trace` that describes each transformation step. See `Babel.Trace` for details.","ref":"Babel.html#apply/2"},{"type":"function","title":"Babel.apply!/2","doc":"Tries to transform the given `data` as described by the given `Babel.Applicable`.\n\nIf the `Babel.Applicable` transforms the data successfully it returns `output`,\nwhere `output` is whatever the given `Babel.Applicable` produces.\n\nIn case of failure a `Babel.Error.t` is raised, whose message includes a `Babel.Trace`\nthat describes each transformation step. See `Babel.Trace` for details.","ref":"Babel.html#apply!/2"},{"type":"function","title":"Babel.at/1","doc":"Alias for `fetch/1`.","ref":"Babel.html#at/1"},{"type":"function","title":"Babel.at/2","doc":"Alias for `fetch/2`.","ref":"Babel.html#at/2"},{"type":"function","title":"Babel.babel?/1","doc":"Returns true when the given value is a `Babel.Pipeline` or a built-in `Babel.Step`.","ref":"Babel.html#babel?/1"},{"type":"function","title":"Examples - Babel.babel?/1","doc":"iex> Babel.babel?(Babel.identity())\n    true\n\n    iex> pipeline = :my_pipeline |> Babel.begin() |> Babel.fetch([:foo, :bar]) |> Babel.map(Babel.cast(:integer))\n    iex> Babel.babel?(pipeline)\n    true\n\n    iex> Babel.babel?(:something)\n    false\n\n    iex> Babel.babel?(\"different\")\n    false","ref":"Babel.html#babel?/1-examples"},{"type":"function","title":"Babel.begin/1","doc":"Begin a new (empty) `Babel.Pipeline`.","ref":"Babel.html#begin/1"},{"type":"function","title":"Babel.call/2","doc":"Equivalent to `call(module, function_name, [])`.","ref":"Babel.html#call/2"},{"type":"function","title":"Babel.call/3","doc":"See `call/4`.","ref":"Babel.html#call/3"},{"type":"function","title":"Babel.call/4","doc":"Calls the specified function with the data as the first argument and the given\nlist as additional arguments.\n\nIf you want to pass the data not as the first argument use `then/1` instead.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#call/4"},{"type":"function","title":"Examples - Babel.call/4","doc":"iex> step = Babel.call(String, :trim, [\"=\"])\n    iex> Babel.apply!(step, \"= some string =\")\n    \" some string \"\n\n    iex> pipeline = Babel.fetch(\"string\") |> Babel.call(String, :trim, [\"=\"])\n    iex> Babel.apply!(pipeline, %{\"string\" => \"= some string =\"})\n    \" some string \"","ref":"Babel.html#call/4-examples"},{"type":"function","title":"Babel.cast/1","doc":"See `cast/2`.","ref":"Babel.html#cast/1"},{"type":"function","title":"Babel.cast/2","doc":"Casts the data to the a boolean, float, or integer.\n\nTo cast data to a different type use either `call/2` or `then/1`.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#cast/2"},{"type":"function","title":"Examples - Babel.cast/2","doc":"iex> step = Babel.cast(:boolean)\n    iex> Babel.apply!(step, \"true\")\n    true\n    iex> Babel.apply!(step, \"FALSE\")\n    false\n    iex> Babel.apply!(step, \" YeS  \")\n    true\n    iex> Babel.apply!(step, \"   no\")\n    false\n\n    iex> step = Babel.cast(:integer)\n    iex> Babel.apply!(step, \"42\")\n    42\n    iex> Babel.apply!(step, 42.6)\n    42\n    iex> Babel.apply!(step, \"  42.6 \")\n    42\n\n    iex> step = Babel.cast(:float)\n    iex> Babel.apply!(step, \"42\")\n    42.0\n    iex> Babel.apply!(step, 42)\n    42.0\n    iex> Babel.apply!(step, \"  42.6 \")\n    42.6\n\n    iex> pipeline = Babel.fetch(\"boolean\") |> Babel.cast(:boolean)\n    iex> Babel.apply!(pipeline, %{\"boolean\" => \" True \"})\n    true","ref":"Babel.html#cast/2-examples"},{"type":"function","title":"Babel.chain/2","doc":"Combines two steps into a `Babel.Pipeline`.\n\nAll steps in a pipeline are evaluated sequentially, an error stops the pipeline,\nunless an `on_error` handler has been set.","ref":"Babel.html#chain/2"},{"type":"function","title":"Babel.choose/1","doc":"Alias for `match/1`.","ref":"Babel.html#choose/1"},{"type":"function","title":"Babel.choose/2","doc":"Alias for `match/2`.","ref":"Babel.html#choose/2"},{"type":"function","title":"Babel.const/1","doc":"Always returns the given value, regardless of what data is passed in.\n\nUseful in combination with `match/1` or `flat_map/1`.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#const/1"},{"type":"function","title":"Examples - Babel.const/1","doc":"iex> step = Babel.const(:my_cool_value)\n    iex> Babel.apply!(step, \"does not matter\")\n    :my_cool_value\n\n    iex> step = Babel.const(42)\n    iex> Babel.apply!(step, \"does not matter\")\n    42","ref":"Babel.html#const/1-examples"},{"type":"function","title":"Babel.fail/1","doc":"Always errors with the given reason. Useful in combination with `match/1` or `flat_map/1`.","ref":"Babel.html#fail/1"},{"type":"function","title":"Examples - Babel.fail/1","doc":"iex> step = Babel.fail(:my_cool_reason)\n    iex> {:error, babel_error} = Babel.apply(step, \"does not matter\")\n    iex> babel_error.reason\n    :my_cool_reason","ref":"Babel.html#fail/1-examples"},{"type":"function","title":"Babel.fetch/1","doc":"See `fetch/2`.","ref":"Babel.html#fetch/1"},{"type":"function","title":"Babel.fetch/2","doc":"Fetches the given path from the data, erroring when it cannot be found.\n\nUse `get/2` to recover to a default.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#fetch/2"},{"type":"function","title":"Examples - Babel.fetch/2","doc":"iex> step = Babel.fetch(:some_key)\n    iex> Babel.apply!(step, %{some_key: \"some value\"})\n    \"some value\"\n\n    iex> step = Babel.fetch([:some_key, \"nested key\", 2])\n    iex> Babel.apply!(step, %{some_key: %{\"nested key\" => [:first, :second, :third, :fourth]}})\n    :third\n\n    iex> pipeline = Babel.fetch(:some_key) |> Babel.fetch(\"nested key\") |> Babel.fetch(-1)\n    iex> Babel.apply!(pipeline, %{some_key: %{\"nested key\" => [:first, :second, :third, :fourth]}})\n    :fourth","ref":"Babel.html#fetch/2-examples"},{"type":"function","title":"Babel.flat_map/1","doc":"See `flat_map/2`.","ref":"Babel.html#flat_map/1"},{"type":"function","title":"Babel.flat_map/2","doc":"Applies the `Babel.Applicable` returned by the given function to each element of an `Enumerable`,\neffectively allowing you to make a choice.\n\nFunctionally equivalent to `Babel.map(Babel.match(fn ... end))`.\n\nUse `map/1` if you want to apply the same applicable to all.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#flat_map/2"},{"type":"function","title":"Examples - Babel.flat_map/2","doc":"iex> step = Babel.flat_map(fn\n    ...>   map when is_map(map) -> Babel.fetch(:some_key)\n    ...>   _ -> Babel.const(:default_value)\n    ...> end)\n    iex> Babel.apply!(step, [%{some_key: \"some value\"}, [not_a: \"map\"]])\n    [\"some value\", :default_value]\n\n    iex> pipeline = Babel.fetch(\"list\") |> Babel.flat_map(fn\n    ...>   map when is_map(map) -> Babel.fetch(:some_key)\n    ...>   _ -> Babel.const(:default_value)\n    ...> end)\n    iex> Babel.apply!(pipeline, %{\"list\" => [%{some_key: \"some value\"}, [not_a: \"map\"]]})\n    [\"some value\", :default_value]","ref":"Babel.html#flat_map/2-examples"},{"type":"function","title":"Babel.get/1","doc":"Equivalent to `get(path, nil)`.","ref":"Babel.html#get/1"},{"type":"function","title":"Babel.get/2","doc":"See `get/3`.","ref":"Babel.html#get/2"},{"type":"function","title":"Babel.get/3","doc":"Fetches the given path from the data, returning the given default when it cannot be found.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#get/3"},{"type":"function","title":"Examples - Babel.get/3","doc":"iex> step = Babel.get(:some_key, :my_default)\n    iex> Babel.apply!(step, %{some_key: \"some value\"})\n    \"some value\"\n\n    iex> step = Babel.get(:some_key, :my_default)\n    iex> Babel.apply!(step, %{})\n    :my_default\n\n    iex> step = Babel.get([:some_key, \"nested key\", 2], :my_default)\n    iex> Babel.apply!(step, %{some_key: %{\"nested key\" => [:first, :second, :third, :fourth]}})\n    :third\n\n    iex> pipeline = Babel.fetch([:some_key, \"nested key\"]) |> Babel.get(-1, :my_default)\n    iex> Babel.apply!(pipeline, %{some_key: %{\"nested key\" => [:first, :second, :third, :fourth]}})\n    :fourth","ref":"Babel.html#get/3-examples"},{"type":"function","title":"Babel.identity/0","doc":"Always returns the data it receives, effectively acting as a noop.\n\nUseful in combination with `match/1` or `flat_map/1`.","ref":"Babel.html#identity/0"},{"type":"function","title":"Examples - Babel.identity/0","doc":"iex> step = Babel.identity()\n    iex> Babel.apply!(step, \"some value\")\n    \"some value\"\n\n    iex> step = Babel.identity()\n    iex> Babel.apply!(step, :another_value)\n    :another_value","ref":"Babel.html#identity/0-examples"},{"type":"function","title":"Babel.into/1","doc":"See `into/2`.","ref":"Babel.html#into/1"},{"type":"function","title":"Babel.into/2","doc":"Transforms the received data into the given data structure, evaluating any\n`Babel.Applicable` it comes across.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#into/2"},{"type":"function","title":"Examples - Babel.into/2","doc":"iex> step = Babel.into(%{atom_key: Babel.fetch(\"string key\")})\n    iex> Babel.apply!(step, %{\"string key\" => \"some value\"})\n    %{atom_key: \"some value\"}\n\n    iex> step = Babel.fetch(:map) |> Babel.into(%{atom_key: Babel.fetch(\"string key\")})\n    iex> Babel.apply!(step, %{map: %{\"string key\" => \"some value\"}})\n    %{atom_key: \"some value\"}","ref":"Babel.html#into/2-examples"},{"type":"macro","title":"Babel.is_babel/1","doc":"Returns true when the given value is a `Babel.Pipeline` or a built-in `Babel.Step`.","ref":"Babel.html#is_babel/1"},{"type":"macro","title":"Examples - Babel.is_babel/1","doc":"iex> Babel.is_babel(Babel.identity())\n    true\n\n    iex> pipeline = :my_pipeline |> Babel.begin() |> Babel.fetch([:foo, :bar]) |> Babel.map(Babel.cast(:integer))\n    iex> Babel.is_babel(pipeline)\n    true\n\n    iex> Babel.is_babel(:something)\n    false\n\n    iex> Babel.is_babel(\"different\")\n    false","ref":"Babel.html#is_babel/1-examples"},{"type":"function","title":"Babel.map/1","doc":"See `map/2`.","ref":"Babel.html#map/1"},{"type":"function","title":"Babel.map/2","doc":"Applies the given `Babel.Applicable` to each element of an `Enumerable`.\n\nUse `flat_map/1` if you need to choose the applicable for each element.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#map/2"},{"type":"function","title":"Examples - Babel.map/2","doc":"iex> step = Babel.map(Babel.fetch(:some_key))\n    iex> Babel.apply!(step, [%{some_key: \"value1\"}, %{some_key: \"value2\"}])\n    [\"value1\", \"value2\"]\n\n    iex> pipeline = Babel.fetch(\"list\") |> Babel.map(Babel.fetch(:some_key))\n    iex> Babel.apply!(pipeline, %{\"list\" => [%{some_key: \"value1\"}, %{some_key: \"value2\"}]})\n    [\"value1\", \"value2\"]","ref":"Babel.html#map/2-examples"},{"type":"function","title":"Babel.match/1","doc":"See `match/2`.","ref":"Babel.html#match/1"},{"type":"function","title":"Babel.match/2","doc":"Applies the `Babel.Applicable` returned by the given function the data,\neffectively allowing you to make a choice.\n\nUse `then/1` if you just want to apply an arbitrary function.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#match/2"},{"type":"function","title":"Examples - Babel.match/2","doc":"iex> step = Babel.match(fn\n    ...>   map when is_map(map) -> Babel.fetch(:some_key)\n    ...>   _ -> Babel.const(:default_value)\n    ...> end)\n    iex> Babel.apply!(step, %{some_key: \"some value\"})\n    \"some value\"\n    iex> Babel.apply!(step, [not_a: \"map\"])\n    :default_value\n\n    iex> pipeline = Babel.fetch(\"nested\") |> Babel.match(fn\n    ...>   map when is_map(map) -> Babel.fetch(:some_key)\n    ...>   _ -> Babel.const(:default_value)\n    ...> end)\n    iex> Babel.apply!(pipeline, %{\"nested\" => %{some_key: \"some value\"}})\n    \"some value\"","ref":"Babel.html#match/2-examples"},{"type":"function","title":"Babel.noop/0","doc":"Alias for `identity/0`.","ref":"Babel.html#noop/0"},{"type":"function","title":"Babel.on_error/2","doc":"Sets the `on_error` handler of a `Babel.Pipeline` which gets called with a\n`Babel.Error` when any given step of a pipeline fails.\n\nOverwrites any previously set `on_error` handler.","ref":"Babel.html#on_error/2"},{"type":"function","title":"Examples - Babel.on_error/2","doc":"iex> pipeline = Babel.fetch(\"some key\") |> Babel.cast(:boolean) |> Babel.on_error(fn %Babel.Error{} -> :recover_to_ok_for_example end)\n    iex> Babel.apply!(pipeline, %{\"some key\" => \"not a boolean\"})\n    :recover_to_ok_for_example","ref":"Babel.html#on_error/2-examples"},{"type":"macro","title":"Babel.pipeline/2","doc":"Syntactic sugar for building a named `Babel.Pipeline` with an optional `on_error` handler.\n\nNote: For future versions we'd like to explore built-in pipeline caching,\n      so that each pipeline only gets built _once_.","ref":"Babel.html#pipeline/2"},{"type":"macro","title":"Examples - Babel.pipeline/2","doc":"","ref":"Babel.html#pipeline/2-examples"},{"type":"macro","title":"Without error handling - Babel.pipeline/2","doc":"Babel.pipeline :my_pipeline do\n      Babel.begin()\n      |> Babel.fetch([\"some\", \"path\"])\n      |> Babel.map(Babel.into(%{some_map: Babel.fetch(:some_key)}))\n    end\n\nWhich would be equivalent to:\n\n    :my_pipeline\n    |> Babel.begin()\n    |> Babel.fetch([\"some\", \"path\"])\n    |> Babel.map(Babel.into(%{some_map: Babel.fetch(:some_key)}))","ref":"Babel.html#pipeline/2-without-error-handling"},{"type":"macro","title":"With error handling - Babel.pipeline/2","doc":"Babel.pipeline :my_pipeline do\n      Babel.begin()\n      |> Babel.fetch([\"some\", \"path\"])\n      |> Babel.map(Babel.into(%{some_map: Babel.fetch(:some_key)}))\n    else\n      %Babel.Error{} = error ->\n        # recover here in some way\n    end\n\nWhich would be equivalent to:\n\n    :my_pipeline\n    |> Babel.begin()\n    |> Babel.fetch([\"some\", \"path\"])\n    |> Babel.map(Babel.into(%{some_map: Babel.fetch(:some_key)}))\n    |> Babel.on_error(fn %Babel.Error{} = error ->\n        # recover here in some way\n    end)","ref":"Babel.html#pipeline/2-with-error-handling"},{"type":"function","title":"Babel.root/0","doc":"Always returns the original data that was given to `Babel`.","ref":"Babel.html#root/0"},{"type":"function","title":"Examples - Babel.root/0","doc":"iex> step = Babel.root()\n    iex> Babel.apply!(step, \"some value\")\n    \"some value\"\n\n    iex> pipeline = Babel.fetch(:list) |> Babel.map(Babel.into(%{\n    ...>   nested_key: Babel.fetch(:key),\n    ...>   root_key: Babel.root() |> Babel.fetch(:key)\n    ...> }))\n    iex> Babel.apply!(pipeline, %{key: \"root value\", list: [%{key: \"nested value1\"}, %{key: \"nested value2\"}]})\n    [\n      %{nested_key: \"nested value1\", root_key: \"root value\"},\n      %{nested_key: \"nested value2\", root_key: \"root value\"}\n    ]","ref":"Babel.html#root/0-examples"},{"type":"function","title":"Babel.then/1","doc":"See `then/3`.","ref":"Babel.html#then/1"},{"type":"function","title":"Babel.then/2","doc":"See `then/3`.","ref":"Babel.html#then/2"},{"type":"function","title":"Babel.then/3","doc":"Applies the given function to the data, basically \"do whatever\".\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#then/3"},{"type":"function","title":"Examples - Babel.then/3","doc":"iex> step = Babel.then(fn _ -> :haha_you_cant_stop_me_from_ignoring_the_input end)\n    iex> Babel.apply!(step, %{some_key: \"some value\"})\n    :haha_you_cant_stop_me_from_ignoring_the_input\n\n    iex> step = Babel.then(fn iso8601 ->\n    ...>   with {:ok, datetime, _offset} <- DateTime.from_iso8601(iso8601) do\n    ...>     {:ok, datetime}\n    ...>   end\n    ...> end)\n    iex> Babel.apply!(step, \"2015-01-23T23:50:07Z\")\n    ~U[2015-01-23 23:50:07Z]\n\n    iex> pipeline = Babel.fetch(\"datetime\") |> Babel.then(fn iso8601 ->\n    ...>   with {:ok, datetime, _offset} <- DateTime.from_iso8601(iso8601) do\n    ...>     {:ok, datetime}\n    ...>   end\n    ...> end)\n    iex> Babel.apply!(pipeline, %{\"datetime\" => \"2015-01-23T23:50:07Z\"})\n    ~U[2015-01-23 23:50:07Z]","ref":"Babel.html#then/3-examples"},{"type":"function","title":"Babel.trace/2","doc":"Like `apply/2` but returns a `Babel.Trace` instead.","ref":"Babel.html#trace/2"},{"type":"function","title":"Babel.try/1","doc":"Like `try/2` but returns the accumulated failure when all steps fail.","ref":"Babel.html#try/1"},{"type":"function","title":"Babel.try/2","doc":"See `try/3`.","ref":"Babel.html#try/2"},{"type":"function","title":"Babel.try/3","doc":"Returns the result of the first `Babel.Applicable` that succeeds.\n\nIf none succeed it either returns the given default or an accumulated error.\n\nSupports composition (you can pipe into this to create a `Babel.Pipeline`).","ref":"Babel.html#try/3"},{"type":"function","title":"Examples - Babel.try/3","doc":"iex> step = Babel.try([Babel.fetch(:atom_key), Babel.fetch(\"string key\")])\n    iex> Babel.apply!(step, %{atom_key: \"some value\"})\n    \"some value\"\n\n    iex> step = Babel.try([Babel.fetch(:atom_key), Babel.fetch(\"string key\")])\n    iex> Babel.apply!(step, %{\"string key\" => \"some value\"})\n    \"some value\"\n\n    iex> step = Babel.try([Babel.fetch(:atom_key), Babel.fetch(\"string key\")])\n    iex> {:error, babel_error} = Babel.apply(step, %{})\n    iex> babel_error.reason\n    [{:not_found, :atom_key}, {:not_found, \"string key\"}]\n\n    iex> step = Babel.try([Babel.fetch(:atom_key), Babel.fetch(\"string key\")], :default_value)\n    iex> Babel.apply!(step, %{})\n    :default_value\n\n    iex> pipeline = Babel.fetch(\"map\") |> Babel.try([Babel.fetch(:atom_key), Babel.fetch(\"string key\")], :default_value)\n    iex> Babel.apply!(pipeline, %{\"map\" => %{}})\n    :default_value","ref":"Babel.html#try/3-examples"},{"type":"type","title":"Babel.data/0","doc":"Arbitrary data structure that ought to be transformed.","ref":"Babel.html#t:data/0"},{"type":"type","title":"Babel.name/0","doc":"Arbitrary term describing a Babel step or pipeline.","ref":"Babel.html#t:name/0"},{"type":"type","title":"Babel.path/0","doc":"A term or list of terms describing a key you'd like to fetch from a data structure.","ref":"Babel.html#t:path/0"},{"type":"type","title":"Babel.t/0","doc":"","ref":"Babel.html#t:t/0"},{"type":"type","title":"Babel.t/1","doc":"","ref":"Babel.html#t:t/1"},{"type":"type","title":"Babel.t/2","doc":"","ref":"Babel.html#t:t/2"},{"type":"exception","title":"Babel.Error","doc":"Represents a failed `Babel.Applicable` evaluation. Contains the reason of the\nreturned `{:error,  }` tuple and a `Babel.Trace`.\n\nThe message of a `Babel.Error` also displays the \"root causes\" of the `Babel.Trace`\n(using `Babel.Trace.root_causes/1`).","ref":"Babel.Error.html"},{"type":"exception","title":"Example - Babel.Error","doc":"Here's an example of how a `Babel.Error` message might look like:\n\n    ** (Babel.Error) Failed to transform data: [not_found: \"string-key\", not_found: \"string-key\", not_found: \"string-key\"]\n\n    Root Cause(s):\n    1. Babel.Trace {\n      data = %{\"unexpected-key\" => :value1}\n\n      Babel.fetch(\"string-key\")\n      |=> {:error, {:not_found, \"string-key\"}}\n    }\n    2. Babel.Trace {\n      data = %{\"unexpected-key\" => :value2}\n\n      Babel.fetch(\"string-key\")\n      |=> {:error, {:not_found, \"string-key\"}}\n    }\n    3. Babel.Trace {\n      data = %{\"unexpected-key\" => :value3}\n\n      Babel.fetch(\"string-key\")\n      |=> {:error, {:not_found, \"string-key\"}}\n    }\n\n    Full Trace:\n    Babel.Trace {\n      data = %{\"some\" => %{\"nested\" => %{\"path\" => [%{\"unexpected-key\" => :value1}, %{\"unexpected-key\" => :value2}, %{\"unexpected-key\" => :value3}]}}}\n\n      Babel.Pipeline<>\n      |\n      | Babel.fetch([\"some\", \"nested\", \"path\"])\n      | |=< %{\"some\" => %{\"nested\" => %{\"path\" => [%{\"unexpected-key\" => :value1}, %{...}, ...]}}}\n      | |=> [%{\"unexpected-key\" => :value1}, %{\"unexpected-key\" => :value2}, %{\"unexpected-key\" => :value3}]\n      |\n      | Babel.map(Babel.into(%{atom_key: Babel.fetch(\"string-key\")}))\n      | |=< [%{\"unexpected-key\" => :value1}, %{\"unexpected-key\" => :value2}, %{\"unexpected-key\" => :value3}]\n      | |\n      | | Babel.into(%{atom_key: Babel.fetch(\"string-key\")})\n      | | |=< %{\"unexpected-key\" => :value1}\n      | | |\n      | | | Babel.fetch(\"string-key\")\n      | | | |=< %{\"unexpected-key\" => :value1}\n      | | | |=> {:error, {:not_found, \"string-key\"}}\n      | | |\n      | | |=> {:error, [not_found: \"string-key\"]}\n      | |\n      | | Babel.into(%{atom_key: Babel.fetch(\"string-key\")})\n      | | |=< %{\"unexpected-key\" => :value2}\n      | | |\n      | | | Babel.fetch(\"string-key\")\n      | | | |=< %{\"unexpected-key\" => :value2}\n      | | | |=> {:error, {:not_found, \"string-key\"}}\n      | | |\n      | | |=> {:error, [not_found: \"string-key\"]}\n      | |\n      | | Babel.into(%{atom_key: Babel.fetch(\"string-key\")})\n      | | |=< %{\"unexpected-key\" => :value3}\n      | | |\n      | | | Babel.fetch(\"string-key\")\n      | | | |=< %{\"unexpected-key\" => :value3}\n      | | | |=> {:error, {:not_found, \"string-key\"}}\n      | | |\n      | | |=> {:error, [not_found: \"string-key\"]}\n      | |\n      | |=> {:error, [not_found: \"string-key\", not_found: \"string-key\", not_found: \"string-key\"]}\n      |\n      |=> {:error, [not_found: \"string-key\", not_found: \"string-key\", not_found: \"string-key\"]}\n    }","ref":"Babel.Error.html#module-example"},{"type":"function","title":"Babel.Error.new/1","doc":"","ref":"Babel.Error.html#new/1"},{"type":"type","title":"Babel.Error.t/0","doc":"","ref":"Babel.Error.html#t:t/0"},{"type":"type","title":"Babel.Error.t/1","doc":"","ref":"Babel.Error.html#t:t/1"},{"type":"module","title":"Babel.Trace","doc":"Represents the evaluation of a `Babel.Applicable`. Contains the evaluated applicable,\nthe input data, the output result, and any traces of nested `Babel.Applicable`s.\n\nImplements `Inspect` to render a human-readable version of the information.\n\nTo analyze a `Babel.Trace` - especially one with `nested` traces - `find/2` will\nbe your friend.","ref":"Babel.Trace.html"},{"type":"function","title":"Babel.Trace.error?/1","doc":"","ref":"Babel.Trace.html#error?/1"},{"type":"function","title":"Babel.Trace.find/2","doc":"Recursively checks all `nested` traces (and this one) against a given spec (or function).\n\nUseful for debugging purposes.","ref":"Babel.Trace.html#find/2"},{"type":"function","title":"Specs - Babel.Trace.find/2","doc":"In addition to being able to pass a function `find/2` supports some convenient shortcuts:\n\n- name of a builtin step (e.g. `:fetch` or `:map`, see below for a full list)\n- the actual step (e.g. `Babel.fetch([\"fetched\", \"path\"])`)\n- a list of all of the above (incl. functions) to recursively find matching traces\n  (e.g. `[:map, :into, :fetch]` to find all fetch traces inside of `Babel.map(Babel.into(...))`)\n\nAll builtin step names:\n- `:call`\n- `:cast`\n- `:const`\n- `:fail`\n- `:fetch`\n- `:flat_map`\n- `:get`\n- `:identity`\n- `:into`\n- `:map`\n- `:match`\n- `:root`\n- `:then`\n- `:try`","ref":"Babel.Trace.html#find/2-specs"},{"type":"function","title":"Examples - Babel.Trace.find/2","doc":"iex> pipeline = Babel.fetch(\"list\") |> Babel.map(Babel.into(%{some_key: Babel.fetch(\"some key\")}))\n    iex> data = %{\"list\" => [%{\"some key\" => \"value1\"}, %{\"some key\" => \"value2\"}]}\n    iex> trace = Babel.trace(pipeline, data)\n    iex> Babel.Trace.find(trace, &Babel.Trace.error?/1)\n    []\n    iex> Babel.Trace.find(trace, :fetch)\n    [\n      Babel.trace(Babel.fetch(\"list\"), data),\n      Babel.trace(Babel.fetch(\"some key\"), %{\"some key\" => \"value1\"}),\n      Babel.trace(Babel.fetch(\"some key\"), %{\"some key\" => \"value2\"}),\n    ]\n    iex> Babel.Trace.find(trace, Babel.fetch(\"list\"))\n    [\n      Babel.trace(Babel.fetch(\"list\"), data)\n    ]\n    iex> Babel.Trace.find(trace, [:into, :fetch])\n    [\n      Babel.trace(Babel.fetch(\"some key\"), %{\"some key\" => \"value1\"}),\n      Babel.trace(Babel.fetch(\"some key\"), %{\"some key\" => \"value2\"}),\n    ]","ref":"Babel.Trace.html#find/2-examples"},{"type":"function","title":"Babel.Trace.matches_spec?/2","doc":"","ref":"Babel.Trace.html#matches_spec?/2"},{"type":"function","title":"Babel.Trace.new/4","doc":"","ref":"Babel.Trace.html#new/4"},{"type":"function","title":"Babel.Trace.ok?/1","doc":"","ref":"Babel.Trace.html#ok?/1"},{"type":"function","title":"Babel.Trace.result/1","doc":"","ref":"Babel.Trace.html#result/1"},{"type":"function","title":"Babel.Trace.root_causes/1","doc":"Returns the nested traces which caused the given trace to fail.\n\nTo be specific it recursively checks all nested traces and collects all error\ntraces which have no nested traces themselves, assuming that this implies that\nthey were the root cause of the failure.","ref":"Babel.Trace.html#root_causes/1"},{"type":"type","title":"Babel.Trace.t/0","doc":"","ref":"Babel.Trace.html#t:t/0"},{"type":"type","title":"Babel.Trace.t/1","doc":"","ref":"Babel.Trace.html#t:t/1"},{"type":"type","title":"Babel.Trace.t/2","doc":"","ref":"Babel.Trace.html#t:t/2"},{"type":"module","title":"Babel.Context","doc":"Passed to `Babel.Applicable.apply/2` wrapping the given `data`.\n\nIn addition it retains a `history` of all previously executed steps by\ncapturing their `Babel.Trace`s.","ref":"Babel.Context.html"},{"type":"function","title":"Babel.Context.new/2","doc":"","ref":"Babel.Context.html#new/2"},{"type":"type","title":"Babel.Context.t/0","doc":"","ref":"Babel.Context.html#t:t/0"},{"type":"type","title":"Babel.Context.t/1","doc":"","ref":"Babel.Context.html#t:t/1"},{"type":"behaviour","title":"Babel.Step","doc":"This module is meant to be used to create your own `Babel` custom steps,\nand is used internally to create all of `Babel`'s built-in steps.\n\nIt's required that any module which `use`s `Babel.Step` defines a struct.","ref":"Babel.Step.html"},{"type":"behaviour","title":"What happens when I `use Babel.Step`? - Babel.Step","doc":"Your struct will:\n\n1. implement the `Babel.Step` behaviour (`c:apply/2`)\n2. implement the `Babel.Applicable` protocol, whose invocations delegate to `c:apply/2`","ref":"Babel.Step.html#module-what-happens-when-i-use-babel-step"},{"type":"behaviour","title":"Inspect - Babel.Step","doc":"If you'd like to customize the `inspect/2` rendition of your custom `Babel.Step`,\nyou can `use Babel.Step, inspect: true`; this will implement the `Inspect` protocol\nand delegate all invocations to `c:inspect/2`.","ref":"Babel.Step.html#module-inspect"},{"type":"callback","title":"Babel.Step.apply/2","doc":"","ref":"Babel.Step.html#c:apply/2"},{"type":"callback","title":"Babel.Step.inspect/2","doc":"","ref":"Babel.Step.html#c:inspect/2"},{"type":"type","title":"Babel.Step.result/1","doc":"","ref":"Babel.Step.html#t:result/1"},{"type":"type","title":"Babel.Step.result_or_trace/1","doc":"","ref":"Babel.Step.html#t:result_or_trace/1"},{"type":"type","title":"Babel.Step.t/0","doc":"An implementation of this behaviour.","ref":"Babel.Step.html#t:t/0"},{"type":"type","title":"Babel.Step.t/1","doc":"An implementation of this behaviour whose `apply/2` function produces the specified output.","ref":"Babel.Step.html#t:t/1"},{"type":"type","title":"Babel.Step.t/2","doc":"An implementation of this behaviour whose `apply/2` function accepts the given input and produces the specified output.","ref":"Babel.Step.html#t:t/2"},{"type":"module","title":"Babel.Test","doc":"You can use this module to test your custom `Babel.Step`s.\n\nIt defines two functions:\n- `apply/2`\n- `apply!/2`\n\nThe difference to `Babel.apply/2` and `Babel.apply!/2` is that they return\nthe \"raw\" result from the step, including in an error case (nothing gets\nwrapped in a `Babel.Error`).\n\n`apply!/2` raises by `assert`ing on the `{:ok, value}` shape of the `apply/2` result.","ref":"Babel.Test.html"},{"type":"function","title":"Babel.Test.apply/2","doc":"","ref":"Babel.Test.html#apply/2"},{"type":"function","title":"Babel.Test.apply!/2","doc":"","ref":"Babel.Test.html#apply!/2"},{"type":"protocol","title":"Babel.Applicable","doc":"The protocol which enables `Babel.apply/2`.\n\nAny custom `Babel.Step` will have to implement this protocol. It's suggested\nto `use Babel.Step` as that will derive an implementation. See `Babel.Step`\nfor further details.","ref":"Babel.Applicable.html"},{"type":"function","title":"Babel.Applicable.apply/2","doc":"","ref":"Babel.Applicable.html#apply/2"},{"type":"type","title":"Babel.Applicable.t/0","doc":"","ref":"Babel.Applicable.html#t:t/0"},{"type":"type","title":"Babel.Applicable.t/1","doc":"","ref":"Babel.Applicable.html#t:t/1"},{"type":"type","title":"Babel.Applicable.t/2","doc":"","ref":"Babel.Applicable.html#t:t/2"},{"type":"protocol","title":"Babel.Fetchable","doc":"The protocol which enables `Babel.fetch/1` and `Babel.get/2`.\n\nBabel ships with implementations for:\n- `List`\n- `Map`\n- `Range`\n- `Tuple`\n\nThe fallback `Any` implementation treats any struct as a `Map`.","ref":"Babel.Fetchable.html"},{"type":"function","title":"Babel.Fetchable.fetch/2","doc":"Fetch the given path from the data","ref":"Babel.Fetchable.html#fetch/2"},{"type":"type","title":"Babel.Fetchable.implementation/0","doc":"","ref":"Babel.Fetchable.html#t:implementation/0"},{"type":"type","title":"Babel.Fetchable.t/0","doc":"Anything that implements this protocol.\n\nHas default implementations for Map, List, and Tuple, and a fallback for structs.","ref":"Babel.Fetchable.html#t:t/0"},{"type":"protocol","title":"Babel.Intoable","doc":"The protocol which enables `Babel.into/1` by recursively evaluating all contained values.\n\nBabel ships with implementations for:\n- `List`\n- `Map`\n- `Tuple`\n\nThe fallback `Any` implementation for structs checks if the struct implements\n`Babel.Applicable`, if yes it invokes `Babel.Applicable.apply/2` on it.\nOtherwise it treats any struct as a `Map`.","ref":"Babel.Intoable.html"},{"type":"function","title":"Babel.Intoable.into/2","doc":"","ref":"Babel.Intoable.html#into/2"},{"type":"type","title":"Babel.Intoable.result/1","doc":"","ref":"Babel.Intoable.html#t:result/1"},{"type":"type","title":"Babel.Intoable.t/0","doc":"Any type that implements this protocol.","ref":"Babel.Intoable.html#t:t/0"},{"type":"module","title":"Babel.Pipeline","doc":"Represents a sequence of `Babel.Step`s (or nested `Babel.Pipeline`s) that get\nevaluated sequentially, when a step fails the pipeline stops and - if set -\ninvokes the `on_error` handler in an attempt to recover from the error.\n\nPipelines can be chained together (using `chain/2`). Babel will try to simplify\npipeline chains by merging pipelines without distinct names and no error handling.","ref":"Babel.Pipeline.html"},{"type":"function","title":"Babel.Pipeline.apply/2","doc":"","ref":"Babel.Pipeline.html#apply/2"},{"type":"function","title":"Babel.Pipeline.chain/2","doc":"Combines a `Babel.Pipeline` either with another `Babel.Pipeline` or a list of\nsteps. Passing another `Babel.Pipeline` might lead both pipelines being merged\ninto one larger `Babel.Pipeline`.","ref":"Babel.Pipeline.html#chain/2"},{"type":"function","title":"Merging - Babel.Pipeline.chain/2","doc":"When all of the following conditions match two `Babel.Pipeline`s get merged:\n\n1. at least one pipeline has no `name` or both `name`s are equal\n2. at least one pipeline has no `on_error` handler\n\nIn all other cases the second `Babel.Pipeline` will be included as a step of\nthe first `Babel.Pipeline`.","ref":"Babel.Pipeline.html#chain/2-merging"},{"type":"function","title":"Babel.Pipeline.new/3","doc":"","ref":"Babel.Pipeline.html#new/3"},{"type":"function","title":"Babel.Pipeline.on_error/2","doc":"","ref":"Babel.Pipeline.html#on_error/2"},{"type":"type","title":"Babel.Pipeline.name/0","doc":"A term describing what this pipeline does","ref":"Babel.Pipeline.html#t:name/0"},{"type":"type","title":"Babel.Pipeline.on_error/0","doc":"","ref":"Babel.Pipeline.html#t:on_error/0"},{"type":"type","title":"Babel.Pipeline.on_error/1","doc":"","ref":"Babel.Pipeline.html#t:on_error/1"},{"type":"type","title":"Babel.Pipeline.step/0","doc":"","ref":"Babel.Pipeline.html#t:step/0"},{"type":"type","title":"Babel.Pipeline.t/0","doc":"","ref":"Babel.Pipeline.html#t:t/0"},{"type":"type","title":"Babel.Pipeline.t/1","doc":"","ref":"Babel.Pipeline.html#t:t/1"},{"type":"type","title":"Babel.Pipeline.t/2","doc":"","ref":"Babel.Pipeline.html#t:t/2"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}